#include <iostream.h>
#include<stdlib.h>
#define SIZE 20 
class HugeInt 
 { 
  public: 
   HugeInt( long = 0 );   // conversion/default constructor 
   HugeInt( const char * );   // conversion constructor 
   
   // add, substract, multiply operations 
   // using regular member functions 
   HugeInt Add_HugeInt( HugeInt ) const; 
   HugeInt Add_HugeInt( const char *) const; 
   HugeInt Add_HugeInt( long) const; 
   
   HugeInt Subtract_HugeInt( HugeInt ) const; 
   HugeInt Subtract_HugeInt( const char * ) const; 
   HugeInt Subtract_HugeInt( long ) const; 
   
   // relational operators: equal, not_equal 
   int operator==( HugeInt ) const; 
   int operator!=( HugeInt ) const; 
   
   // Add any public members and member functions here 
   
   // input, output 
   friend istream& operator>>( istream&, HugeInt& ); 
   friend ostream& operator<<( ostream&, HugeInt& ); 

private: 
   unsigned short integer[SIZE+1]; // integer[0] is the sign of the HugeInt 
   // integer[0]== 0, HugeInt is positive 
   // integer[0] ==0xFF, HugeInt is negative 
   
   // Add any private members and member functions here 
   
};
/*Constructor with string*/
HugeInt::HugeInt(const char* input)
{
  int i,temp;
  temp=strlen(input);
  for(i=0;i<(SIZE+1);i++)
    {
      integer[i] =0;
    }  
  
  int j=0;
  
  if(input[0] == '-')
    { 
      integer[0] = 0xFF;
      j = 1;
    }
  
  for(i=(temp-1);i>=j;i--)
    {
      char number[2];
      number[0] = input[i];
      number[1] = '\0'; 
      integer[i+SIZE+1-temp]=atoi(number);
    }
}

/*Constructor with int*/
HugeInt::HugeInt( long val ) 
{ 
  int i; 
  long tmp; 
  for(i=0; i<=SIZE; i++) integer[i] = 0;  //initialize array to zero 
  
  if( val < 0 ){ 
    tmp = abs( val ); 
    integer[0] = 0xFF; 
  } 
  else 
    tmp = val; 
  
  for( i = SIZE; i >= 1; i-- ){ 
    integer[i] = tmp % 10; 
    tmp /= 10; 
  } 
}

/*Add 1*/
HugeInt HugeInt::Add_HugeInt(HugeInt add1)const
{
  HugeInt result(0.0);
  int carry = 0;
  int i;
  int res;
  if((integer[0] == 0xFF) XOR ((add1.integer[0]) == 0xFF))
    {
      if(integer[0] == 0xFF)
        {
          return (add1.Subtract(this));
        }
      else
        {
          return (this.Subtract_HugeInt(add1));
        }
    }    
  else
    {
      for(i=SIZE;i>0;i--)
        {
          res = integer[i]+add1.integer[i]+carry;
          if(res>=10)
            {
              carry = 1;
              res-=10;
              result.integer[i]=res;
            }
          else
            {
              carry = 0;
              result.integer[i]=res;
            }
        }
      if(integer[i] == 0xFF)
        {
          result.integer[0] = 0xFF;
        }
    }
  return result;
}

/*Add 2*/
HugeInt HugeInt::Add_HugeInt(const char *add2)const
{
  HugeInt add02(add2);
  return (this.Add_HugeInt(add02));
}   

/*Add 3*/ 
HugeInt HugeInt::Add_HugeInt(const long add3)const
{
  HugeInt add03(add3);
  return (this.Add_HugeInt(add03));
}

/*Subtract 1*/
HugeInt HugeInt::Subtract_HugeInt(HugeInt sub1)const
{
  HugeInt result(0);
  int carry = 0;
  int i =0;
  int gt = 0;
  if(integer[0] == 0xFF)
    {
      if(sub1.integer[0] == 0xFF)
        {
          sub1.integer[0] = 0;
          return (sub1.Subtract_HugeInt(this));
        }
      else
        {
          sub1.integer[0] = 0xFF;
          return (sub1.Add_HugeInt(this));
        }
    }
  else
    {
      if(sub1.integer[0] == 0xFF)
        {
          sub1.integer[0] = 0;
          return (this.Add_HugeInt(sub1));
        }
      else
        {
          for(i=1;i<=SIZE;i++)
            {
              if(integer[i]>sub1.integer[i])
                {
                  gt = 1;
                  break;
                }
              else if(integer[i]<sub1.integer[i])
                {
                  gt = 2;
                  break;
                }
            }
          if(gt == 0)
            {
              return result;
            }
          else if(gt ==1)
            {
              for(i = SIZE;i>0;i--)
                {
                  if((integer[i]-carry)>=sub1.integer[i])
                    {
                      result[i] = integer[i]-carry-sub1.integer[i];
                      carry = 0;
                    }
                  else 
                    {
                      result[i] = integer[i]+10-carry-sub1.integer[i];
                      carry = 1;
                    }
                }
            }
          else if(gt == 2)
            {
              for(i = SIZE;i>0;i--)
                {
                  if((sub1.integer[i]-carry)>=integer[i])
                    {
                      result[i] = sub1.integer[i]-carry-integer[i];
                      carry = 0;
                    }
                  else 
                    {
                      result[i] = sub1.integer[i]+10-carry-integer[i];
                      carry = 1;
                    }
                }
              result[0] = 0xFF;
            }
        }
      return (result);
    }
}

/*Subtract 2*/
HugeInt HugeInt::Subtract_HugeInt(constant char *sub2)const
{
  HugeInt sub02(sub2);
  return (this.Subtract_HugeInt(sub02));
}

/*Subtract 3*/
HugeInt HugeInt::Subtract_HugeInt(long sub3)const
{
  HugeInt sub03(sub3);
  return (this.Subtract_HugeInt(sub03));
}



/* overloaded output operator*/
ostream &operator<<(ostream &output, const HugeInt &out) const
{
 int i=1;
 for(i=1;1<=SIZE;i++)
 {
  output<<out.interget[i];
 }
 return output;
}

/* overloaded input operator*/
istream &operator>>(istream &input, HugeInt &inp)const
{
 char temp[100];
 input>>temp;
 inp=temp;
 return input;
} 


/*relational operator ==*/
int HugeInt::operator==(const HugeInt &equal)const 
{
 int i;
 int temp=0;
 for(i=0;i<=SIZE;i++)
 { 
   if(integer[i]!=equal.interger[i])
   temp=1;
  } 
   return(temp);
 }   
/*relational operator!=*/
int HugeInt::operator!=(const HigeInt &notequ)const
{
 int i;
 int temp=0;
 for(i=0;i<=SIZE;i++)
 {
  if(integer[i]==notequ.integer[i])
  temp=1;
 }
 return(temp);
} 

int main() 
{ 


  HugeInt n1( -1 ), n2( 100 ), 
          n3( "9999999999999999999" ), 
          n4( "-1" ), n5, n6, n7; 
  cout << "n1 is " << n1 << "\nn2 is " << n2 
          << "\nn3 is " << n3 << "\nn4 is " << n4 << endl << endl; 

  n5 = n1.Add_HugeInt( n2 ); 
  cout << n1 << " + " << n2 << " = " << n5 << "\n\n"; 
  n5 = n2.Add_HugeInt( n1 ); 
  cout << n2 << " + " << n1 << " = " << n5 << "\n\n"; 

  n5 = n1.Subtract_HugeInt( n2 ); 
  cout << n1 << " - " << n2 << " = " << n5 << "\n\n"; 
  n5 = n2.Subtract_HugeInt( n1 ); 
  cout << n2 << " - " << n1 << " = " << n5 << "\n\n"; 

  n5 = n3.Subtract_HugeInt( n4 ); 
  cout << n3 << " - " << n4 << " = " << n5  << "\n\n"; 
  n5 = n4.Subtract_HugeInt( n3 ); 
  cout << n4 << " - " << n3 << " = " << n5  << "\n\n"; 

  n5 = n1.Subtract_HugeInt( 9 ); 
  cout << n1 << " - " << 9 << " = " << n5 << "\n\n"; 

  n5 = n2.Subtract_HugeInt( "10000" ); 
  cout << n2 << " - " << "10000" << " = " << n5 << "\n\n"; 
  if( n1 == n2 ) cout << n2 << " == " << n1 << "\n\n"; 
  if( n1 != n2 ) cout << n2 << " != " << n1 << "\n\n"; 

  cout << "Input n6:"; 
  cin >> n6; 
  cout << "Input n7:"; 
  cin >> n7; 
  n5 = n6.Add_HugeInt( n7 ); 
  cout << n6 << " + " << n7 << " = " << n5 << "\n\n"; 

  return 0; 
}
