/********************************************************
*	Name : Atul Nayak				*
*	tele.hxx : Header file for the teleporter	*
********************************************************/	
class teleporter
{

	private:
		int noOfPolygons;		// number of polygons that make a teleporter
		GLfloat colors[3];		// the color of the teleporter
		vector<int> noOfVertices;	// vector of number of vertices in each polygon
		vector<GLfloat> vertices;	// vertices in each polygon
		int positionX;			// the X position of the teleporter in the maze
		int positionY;			// the X position of the teleporter in the maze
		float angle;			// the teleporter's  angle of rotation

	
	public:
		// constructor 
		teleporter();	

		// draw the teleporter at the location specified by x and y		
		void drawTeleporter(int x, int y);	

		// get the x position
		int getPositionX();

		// get the y position
		int getPositionY();
		
		// if the teleporter is within 10 feet make the teleporter bright	
		void brightestColor();

		// if the teleporter is 110 feet away darken it
		void darkestColor();

		// change the color of the teleporter in proportion to the distance from the viewer
		void changeColor(float);

		// destructor
		~teleporter();

};
