/****************************************************************	
* Name : Atul Nayak						*
* orb.cxx : Header file of class orb				*
****************************************************************/	     

class orb
{

	private:
		
		// number of polygons that make a orb	
		int noOfPolygons;

		// the color of the orb		
		GLfloat colors[3];

		// vector of number of vertices in each polygon		
		vector<int> noOfVertices;

		// vertices in each polygon	
		vector<GLfloat> vertices;

		// the X position of the orb in the Maze array at start	
		int positionX;

		// the Y position of the orb in the Maze array at start	
		int positionY;

		// flag to indicate whether teh Orb was taken or not
		int orbTaken;
	
	public:
		
		// constructor - reads the orb.txt file
		orb();

		// draw Orb at the specified position 
		void drawOrb(int x, int y);

		// return positionX
		int getPositionX();

		// return positionY
		int getPositionY();

		// set the color to it's maximum intensity	
		void brightestColor();

		// set the color to it's minimum intensity
		void darkestColor();

		// set the door color to an intermediate value specified
		void changeColor(float);

		// set the orbTaken flag
		void setOrbTaken();

		// destructor
		~orb();

};
