/****************************************************************	
* Name : Atul Nayak						*
* ped.cxx : Header file of class ped				*
****************************************************************/	     


class ped
{

	private:

		// number of polygons that make a pedestal
		int noOfPolygons;

		// the color of the pedestal		
		GLfloat colors[3];

		// vector of number of vertices in each polygon
		vector<int> noOfVertices;	

		// vertices in each polygon
		vector<GLfloat> vertices;	

		// the X position of the orb in the Maze array at start
		int positionX;

		// the Y position of the orb in the Maze array at start
		int positionY;

		// flag to indicate whether teh Orb was taken or not 
		int orbTaken;
	
	public:
		
		// constructor
		ped();

		// draw the pedestal at the specified location
		void drawPed(int x, int y);
		
		// return positionX
		int getPositionX();

		// return positionY
		int getPositionY();

		// set the color to it's maximum intensity
		void brightestColor();

		// set the color to it's minimum intensity
		void darkestColor();
		
		// set the door color to an intermediate value specified
		void changeColor(float);

		// make the pedestal red in color
		void makeRed();

		// set the orbTaken flag
		void setOrbTaken();

		// destructor
		~ped();
};
